//*******************************************************
//@ohbPUkePWQV `lIterpRvOiVAԊOMɂj
//   PIC16LF1827 Remote Control for TV(with Channel Select, with Serial IR Transmitter)
//  file name: 16lf1827_tv_channel_main.c
//
//
//   MPLAB IDE v8.84  HiTEC C
//
//  2022/01/04  New  Programed by Taishi
//  2022/01/11  Modify for TV Conrol with Channel Select by Taishi
//*******************************************************

#include	<htc.h>

#include	"16lf1827_tv_channel.h"

//#define	_XTAL_FREQ	32000000L	//	giWlgS{j

// CONFIG for 16LF1827

__CONFIG (	FCMEN_OFF			//	0(OFF) = tFCZ[t NbNj^𖳌ɂ
		&	IESO_OFF			//	0(OFF) = tFCZ[t NbNj^𖳌ɂ
		&	CLKOUTEN_OFF		//	1(OFF) = CLKOUT@\𖳌ɂBCLKOUT sI/O Ƃċ@\
		&	BOREN_ON			//	11 = BOR(uEAEgZbg)Lɂ
		&	CPD_OFF				//	1(OFF) = f[^̃R[hی𖳌ɂ
		&	CP_OFF				//	1(OFF) = vÕR[hی𖳌ɂ
		&	MCLRE_ON			//	1(ON) = MCLR/VPP s̓Zbg[qƂċ@\B
		&	PWRTE_ON			//	0 = PWRT(p[Abv^C}[)Lɂ
		&	WDTE_OFF			//	00 = WDT(EHb`hbO^C}[)𖳌ɂ
		&	FOSC_INTOSC			//	100 = INTOSCIV[^:CLKIN sI/O Ƃċ@\
);

								//	fobO@\͏ݑuɔCij

__CONFIG (	LVP_OFF				//	0(OFF)=vO~OMCLR ɍdKv
		&	BORV_LO				//	1 = uEAEgZbgd(Vbor)̃gbv|Cgɐݒ肷
		&	STVREN_ON			//	1(ON) = X^bÑI[o[t[܂̓A_[t[ɂăZbg𔭐
		&	PLLEN_OFF			//	0 = 4xPLL vOݒɂ
		&	WRT_OFF				//	11 = ݕیOFF ɂ
);

//*******************************************************
//************ TV Channel remote Conrol *****************
//*******************************************************

//*******************************************************
// Transmit Data (NEC format) REGZA
//*******************************************************
char	str_nec_form[13][5]={				// [0][]=Power, [1][]=Vol Up, [2][]=Vol Down, [3][]=Ch Up, [4][]=Ch Down......
			{0x02,0xfd,0x48,0xb7,0x00},		// Power
			{0x02,0xfd,0xd8,0x27,0x00},		// Ch Up
			{0x02,0xfd,0xf8,0x07,0x00},		// Ch Down
			{0x02,0xfd,0x78,0x87,0x00},		// Vol Down
			{0x02,0xfd,0x58,0xa7,0x00},		// Vol Up

			{0x02,0xfd,0x80,0x7f,0x00},		// Ch1 select
			{0x02,0xfd,0x40,0xbf,0x00},		// Ch2 select
			{0x02,0xfd,0xc0,0x3f,0x00},		// Ch3 select
			{0x02,0xfd,0x20,0xdf,0x00},		// Ch4 select
			{0x02,0xfd,0xa0,0x5f,0x00},		// Ch5 select
			{0x02,0xfd,0x60,0x9f,0x00},		// Ch6 select
			{0x02,0xfd,0xe0,0x1f,0x00},		// Ch7 select
			{0x02,0xfd,0x10,0xef,0x00},		// Ch8 select
		};


//*******************************************************
// Transmit Leader Data
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_nec_leader(void)
{
	MDBIT = 0;				// 38kHz ON
	__delay_us(9000);		// 9ms Wait;
	MDBIT = 1;				// 38kHz OFF

	__delay_us(4500);		// 4.5ms Wait;
}

//*******************************************************
// Transmit Trailer Data
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_nec_trailer(void)
{
	MDBIT = 0;				// 38kHz ON
	__delay_us(560);		// 560us Wait;
	MDBIT = 1;				// 38kHz OFF

	__delay_us(40000);		// 40ms Wait;

}

//*******************************************************
// Transmit Repeat Data
//*******************************************************
void	tx_nec_repeat(void)
{
	tx_nec_leader();		// Transmit Leader Data
	tx_nec_trailer();		// Transmit Trailer Data
	__delay_us(55000);		// 55ms Wait;
}

//*******************************************************
// Transmit NEC Form 1Byte
//  arg c : Transmit Data(1byte)
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_nec_form_char(char c)
{
	unsigned char	i;
	unsigned char	b=0x80;

	for(i=0;i<8;i++,b >>= 1){	// Bit7 --> Bit0 Transmit
		MDBIT = 0;				// 38kHz ON
		__delay_us(560);		// 560us Wait;
		MDBIT = 1;				// 38kHz OFF
		if((c & b)==0){			// Bit : 0
			__delay_us(560);	// 560us Wait;
		}else{					// Bit : 1
			__delay_us(1690);	// 1.69ms Wait;
		}
	}

}

//*******************************************************
// Transmit NEC format
//   arg sFstring pointer (termnate:0x00)
//*******************************************************
void	tx_nec_form_str(char *s)
{
	tx_nec_leader();			// Transmit Leader Data

	while(*s != 0x00){
		tx_nec_form_char(*s);	// Transmit 1Byte
		s++;
	}

	tx_nec_trailer();			// Transmit Trailer Data

}

//*******************************************************
// proc Switch ON
//   arg n: Switch No.(1,2,3,4 ,,,, 13j
//*******************************************************
void	proc_nec_switch_on(unsigned char n)
{
	unsigned char	renzoku_count;		// Af[^Ԋui̒l x 10msj
	unsigned char	on_jikan;			// 10mS x ̒lĂԂɂȂ

//	if((n == 1) || (n == 2) || (n == 3) || (n == 4) || (n == 5)){
	if((1 <= n) && (n <= 13)){
		MDEN = 1;						// DSM Module Validity

		tx_nec_form_str(&str_nec_form[n-1][0]);	// Transmit Data(String)

		while(1){
			if(n == 1){						// Switch No = 1
				if(SW1_BIT != 0){			// S1:high
					__delay_ms(20);			// 20ms Wait
					if(SW1_BIT != 0){		// S1:high Check Twice
						break;
					}
				}
			}else if(n == 2){				// Switch No = 2
				if(SW2_BIT != 0){			// S2:high
					__delay_ms(20);			// 20ms Waiy
					if(SW2_BIT != 0){		// S2:high Check Twice
						break;
					}
				}
			}else if(n == 3){				// Switch No = 3
				if(SW3_BIT != 0){			// S3:high
					__delay_ms(20);			// 20ms Waiy
					if(SW3_BIT != 0){		// S3:high Check Twice
						break;
					}
				}
			}else if(n == 4){				// Switch No = 4
				if(SW4_BIT != 0){			// S4:high
					__delay_ms(20);			// 20ms Waiy
					if(SW4_BIT != 0){		// S4:high Check Twice
						break;
					}
				}
			}else if(n == 5){				// Switch No = 5
				if(SW5_BIT != 0){			// S5:high
					__delay_ms(20);			// 20ms Waiy
					if(SW5_BIT != 0){		// S5:high Check Twice
						break;
					}
				}
			}else if(n == 6){				// Switch No = 6
				if(SW6_BIT != 0){			// S6:high
					__delay_ms(20);			// 20ms Waiy
					if(SW6_BIT != 0){		// S6:high Check Twice
						break;
					}
				}
			}else if(n == 7){				// Switch No = 7
				if(SW7_BIT != 0){			// S7:high
					__delay_ms(20);			// 20ms Waiy
					if(SW7_BIT != 0){		// S7:high Check Twice
						break;
					}
				}
			}else if(n == 8){				// Switch No = 8
				if(SW8_BIT != 0){			// S8:high
					__delay_ms(20);			// 20ms Waiy
					if(SW8_BIT != 0){		// S8:high Check Twice
						break;
					}
				}
			}else if(n == 9){				// Switch No = 9
				if(SW9_BIT != 0){			// S9:high
					__delay_ms(20);			// 20ms Waiy
					if(SW9_BIT != 0){		// S9:high Check Twice
						break;
					}
				}
			}else if(n == 10){				// Switch No = 10
				if(SW10_BIT != 0){			// S10:high
					__delay_ms(20);			// 20ms Waiy
					if(SW10_BIT != 0){		// S10:high Check Twice
						break;
					}
				}
			}else if(n == 11){				// Switch No = 11
				if(SW11_BIT != 0){			// S11:high
					__delay_ms(20);			// 20ms Waiy
					if(SW11_BIT != 0){		// S11:high Check Twice
						break;
					}
				}
			}else if(n == 12){				// Switch No = 12
				if(SW12_BIT != 0){			// S12:high
					__delay_ms(20);			// 20ms Waiy
					if(SW12_BIT != 0){		// S12:high Check Twice
						break;
					}
				}
			}else if(n == 13){				// Switch No = 13
				if(SW13_BIT != 0){			// S13:high
					__delay_ms(20);			// 20ms Waiy
					if(SW13_BIT != 0){		// S13:high Check Twice
						break;
					}
				}
			}

			tx_nec_repeat();			// Transmit Repeat Data
		}

		MDEN = 0;						// DSM Module Invalidity

	}
}

//*******************************************************
// C
//*******************************************************
void	main(void)
{
	unsigned char	i;

	di();						//	荞݋֎~

//				76543210
	OSCCON	= 0b11110000;		//	NbNWlg@c@okkHLȂ̂ŎRQlg

//				76543210		//  |[g`
	ANSELA	= 0b00000000;		//	ăfW^óiAiO͋֎~j
	PORTA	= 0b11111111;		//	o̓f[^ݒ(PA0 -> PA7 : 1)
	TRISA	= 0b11111111;		//	o͕ݒ(0:OUTPUT, 1:INPUT)
	WPUA	= 0b00100000;		//	vAbvݒ(PA5:ON vAbvÃrbgɂ̓vAbv݂͑Ȃ)

//				76543210		//  |[ga
	ANSELB	= 0b00000000;		//	ăfW^óiAiO͋֎~j
	PORTB	= 0b11110111;		//	o̓f[^ݒ(PB3:0)
	TRISB	= 0b11110111;		//	o͕ݒ(0:OUTPUT, 1:INPUT, PB3:OUTPUT(DSM
	WPUB	= 0b00000000;		//	vAbvݒ

	OPTION_REGbits.nWPUEN = 0;	// WPUEN:0 vAbvL


// --------------------------------------------------------------------------------
// --------------@n[h`FbÑvO@----------------------------
// ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||


// ----------------- Hard Check LED (Endless loop) ----------------------------
// ----- QTOr@kdc@nm@
// ----- QTOr@kdc@nee@
// ----- iɌJԂ

#ifdef	LED_TEST

	while(1){
		PORTB ^= 0x08;			//  Infrared  LED ON or OFF
		__delay_ms(250);		//	Wait 250mS;
	}
#endif

// ---------------- Hard Check Switch (Endless loop) --------------------------
// ----- Qbԁ@kdc@nee 
// ----- Pbԁ@kdc@nm@
// ----- POOr@kdc@nee@Ɓ@
// ----- POOr@kdc@nm@XCb`ԍJԂ
// ----- Qbԁ@kdc@neeɖ߂
// ----- 
// ----- Qbԁ@kdc@nee̊ԂɉꂽXCb`(SW1--SW13)XCb`ԍiP||PRjɂȂ

#ifdef	SW_TEST					// Hard Check Switch
	{
		unsigned char	s = 1;

		while(1){

			// --------------------- LED off 2S ----------------------------
			PORTB &= ~0x08;							//  Infrared  LED OFF
			for(i=0;i<100;i++){
				__delay_ms(20);						//	Wait 20mS;
				if(SW1_BIT == 0){					// S1:Low
					__delay_ms(20);					//	QOҋ@
					if(SW1_BIT == 0){				// S1:Low Qx@{Low
						s = 1;						// Switch-1 ON
					}
				}

				if(SW2_BIT == 0){					// S2:Low
					__delay_ms(20);					//	QOҋ@
					if(SW2_BIT == 0){				// S2:Low Qx@{Low
						s = 2;						// Switch-2 ON
					}
				}

				if(SW3_BIT == 0){					// S3:Low
					__delay_ms(20);					//	QOҋ@
					if(SW3_BIT == 0){				// S3:Low Qx@{Low
						s = 3;						// Switch-3 ON
					}
				}

				if(SW4_BIT == 0){					// S4:Low
					__delay_ms(20);					//	QOҋ@
					if(SW4_BIT == 0){				// S4:Low Qx@{Low
						s = 4;						// Switch-4 ON
					}
				}

				if(SW5_BIT == 0){					// S5:Low
					__delay_ms(20);					//	QOҋ@
					if(SW5_BIT == 0){				// S5:Low Qx@{Low
						s = 5;						// Switch-5 ON
					}
				}

				if(SW6_BIT == 0){					// S6:Low
					__delay_ms(20);					//	QOҋ@
					if(SW6_BIT == 0){				// S6:Low Qx@{Low
						s = 6;						// Switch-6 ON
					}
				}

				if(SW7_BIT == 0){					// S7:Low
					__delay_ms(20);					//	QOҋ@
					if(SW7_BIT == 0){				// S7:Low Qx@{Low
						s = 7;						// Switch-7 ON
					}
				}

				if(SW8_BIT == 0){					// S8:Low
					__delay_ms(20);					//	QOҋ@
					if(SW8_BIT == 0){				// S8:Low Qx@{Low
						s = 8;						// Switch-8 ON
					}
				}

				if(SW9_BIT == 0){					// S9:Low
					__delay_ms(20);					//	QOҋ@
					if(SW9_BIT == 0){				// S9:Low Qx@{Low
						s = 9;						// Switch-9 ON
					}
				}

				if(SW10_BIT == 0){					// S10:Low
					__delay_ms(20);					//	QOҋ@
					if(SW10_BIT == 0){				// S10:Low Qx@{Low
						s = 10;						// Switch-10 ON
					}
				}

				if(SW11_BIT == 0){					// S11:Low
					__delay_ms(20);					//	QOҋ@
					if(SW11_BIT == 0){				// S11:Low Qx@{Low
						s = 11;						// Switch-11 ON
					}
				}

				if(SW12_BIT == 0){					// S12:Low
					__delay_ms(20);					//	QOҋ@
					if(SW12_BIT == 0){				// S12:Low Qx@{Low
						s = 12;						// Switch-12 ON
					}
				}

				if(SW13_BIT == 0){					// S13:Low
					__delay_ms(20);					//	QOҋ@
					if(SW13_BIT == 0){				// S13:Low Qx@{Low
						s = 13;						// Switch-13 ON
					}
				}
			}


			// --------------------- LED on 1S --------------------------
			PORTB |= 0x08;							//  Infrared  LED ON
			__delay_ms(1000);						//	Wait 1000mS;
			PORTB &= ~0x08;							//  Infrared  LED OFF
			__delay_ms(100);						//	Wait 100mS;

			// ---------------- LED on 1time --> 13times ----------------
			for(i=0; i<s; i++){
				PORTB |= 0x08;							//  Infrared  LED ON
				__delay_ms(100);						//	Wait 100mS;
				PORTB &= ~0x08;							//  Infrared  LED OFF
				__delay_ms(100);						//	Wait 100mS;
			}
		}
	}

#endif

// ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
// --------------@܂Ńn[h`FbÑvO@----------------------------
// --------------------------------------------------------------------------------

	for(i=0;i<10;i++){
		PORTB ^= 0x08;			//  Infrared  LED ON or OFF							<-- TV Channel Remote
		__delay_ms(500);		//	TOOҋ@;
	}

	// Timer1 Init. gȂ
	T1CON  = 0b00000000;		// Fosc/4, prescaler 1:1, timer1osc:dis, sync Fosc, ~
	T1GCON = 0b00000000;		// Timer1 Not Link Gate
	TMR1H  = 0;					// Uper Reg
	TMR1L  = 0;					// Lower Reg

	// DSM(Digital Signal Modurator) ̐ݒ@inm^neeL[COj

	//  bboPgɂāAlcahsMi\tgjϒMƂ
	//    o͔]ĂȂA̔guŁ@k̔gbboPiovljȂ̂Ł@
	//    ϒM ̎͂kóAk͕̎ϒMiovljoB
	MDCON  = 0b01000001;		// W[Aso͂͗LAX[[gAo͔]ȂAlcahs͔gggp
	MDSRC  = 0b10000000;		// W[^M̏o̓sFAW[^MFMDBIT
	MDCARH = 0b10000000;		// Ig̏o̓sFAggFVss
	MDCARL = 0b10000100;		// Ig̏o̓sFAkgFCCP1(PWM)


	// 38KHz ̔g`o  26.32uSAFosc/4(8MHz) ŃJEg 210 ɂȂ
	//  ^C}[QJEg^C}[ɂȂ
	T2CON= 0b00000000;			// |XgXP[1:1A܂~AvXP[P
	TMR2    = 0;				// ^C}[l[NAilj
	PR2 = 210;					// 38kHz

	// CCP1 Init.
	CCPR1L = PR2/2;				// 50:50 PWMf[eBig̎ԁj
	CCP1CON = 0b00001100;		// PWM[hVOo
	TMR2ON  = 1;				// ^C}[QX^[g

	MDMSODIS = 0;				// MSD X^[g


// Remote Control
	while(1){
		if(SW1_BIT == 0){					// S1:Low
			__delay_ms(20);					//	QOҋ@
			if(SW1_BIT == 0){				// S1:Low Qx@{Low
				proc_nec_switch_on(1);		//Proc Switch-1 ON
			}
		}

		if(SW2_BIT == 0){					// S2:Low
			__delay_ms(20);					//	QOҋ@
			if(SW2_BIT == 0){				// S2:Low Qx@{Low
				proc_nec_switch_on(2);		//Proc Switch-2 ON
			}
		}

		if(SW3_BIT == 0){					// S3:Low
			__delay_ms(20);					//	QOҋ@
			if(SW3_BIT == 0){				// S3:Low Qx@{Low
				proc_nec_switch_on(3);		//Proc Switch-3 ON
			}
		}

		if(SW4_BIT == 0){					// S4:Low
			__delay_ms(20);					//	QOҋ@
			if(SW4_BIT == 0){				// S4:Low Qx@{Low
				proc_nec_switch_on(4);		//Proc Switch-4 ON
			}
		}

		if(SW5_BIT == 0){					// S5:Low
			__delay_ms(20);					//	QOҋ@
			if(SW5_BIT == 0){				// S5:Low Qx@{Low
				proc_nec_switch_on(5);		//Proc Switch-5 ON
			}
		}

		if(SW6_BIT == 0){					// S6:Low
			__delay_ms(20);					//	QOҋ@
			if(SW6_BIT == 0){				// S6:Low Qx@{Low
				proc_nec_switch_on(6);		//Proc Switch-6 ON
			}
		}

		if(SW7_BIT == 0){					// S7:Low
			__delay_ms(20);					//	QOҋ@
			if(SW7_BIT == 0){				// S7:Low Qx@{Low
				proc_nec_switch_on(7);		//Proc Switch-7 ON
			}
		}

		if(SW8_BIT == 0){					// S8:Low
			__delay_ms(20);					//	QOҋ@
			if(SW8_BIT == 0){				// S8:Low Qx@{Low
				proc_nec_switch_on(8);		//Proc Switch-8 ON
			}
		}

		if(SW9_BIT == 0){					// S9:Low
			__delay_ms(20);					//	QOҋ@
			if(SW9_BIT == 0){				// S9:Low Qx@{Low
				proc_nec_switch_on(9);		//Proc Switch-9 ON
			}
		}

		if(SW10_BIT == 0){					// S10:Low
			__delay_ms(20);					//	QOҋ@
			if(SW10_BIT == 0){				// S10:Low Qx@{Low
				proc_nec_switch_on(10);		//Proc Switch-10 ON
			}
		}

		if(SW11_BIT == 0){					// S11:Low
			__delay_ms(20);					//	QOҋ@
			if(SW11_BIT == 0){				// S11:Low Qx@{Low
				proc_nec_switch_on(11);		//Proc Switch-11 ON
			}
		}

		if(SW12_BIT == 0){					// S12:Low
			__delay_ms(20);					//	QOҋ@
			if(SW12_BIT == 0){				// S12:Low Qx@{Low
				proc_nec_switch_on(12);		//Proc Switch-12 ON
			}
		}

		if(SW13_BIT == 0){					// S13:Low
			__delay_ms(20);					//	QOҋ@
			if(SW13_BIT == 0){				// S13:Low Qx@{Low
				proc_nec_switch_on(13);		//Proc Switch-13 ON
			}
		}


#ifdef	USE_SLEEP
		// ----------- Use SLEEP Proguram ----------

		IOCBP = 0x00;					// オGbWԕω荞݃WX^FNAiׂĖj
		IOCBN0 = 1;						// qaOGbWԕω荞݁FL
		IOCBN1 = 1;						// qaPGbWԕω荞݁FL
		IOCBN2 = 1;						// qaPGbWԕω荞݁FL
		IOCBN4 = 1;						// qaPGbWԕω荞݁FL
		IOCBN5 = 1;						// qaPGbWԕω荞݁FL
		IOCBN6 = 1;						// qaPGbWԕω荞݁FL
		IOCBN7 = 1;						// qaPGbWԕω荞݁FL
		IOCBF = 0x00;					// ԕω荞݃tOWX^ otONA
		IOCIE = 1;						// ԕω荞݁FL
		PEIE = 1;						// Ӌ@\荞݁FL

		SLEEP();						// 啶ɒӁII
		NOP();							// 啶ɒӁII

#else
		// ---------- Use Polling Program ----------

		OSCCON	= 0b01110000;							//	PLL Disable
		OSCCON	= 0b00000000;							//	Change 31kHz(LF)

		while(1){
			// ---- Port-A Check ----
			if((PORTA & 0b11011111) != 0b11011111){
				__delay_us(1);							//	1ҋ@igxĂ̂łłPr炢̂͂j
				if((PORTA & 0b11011111) != 0b11011111){	// Qx
					break;								// [v甲
				}
			}

			// ---- Port-B Check ----
			if((PORTB & 0b11110101) != 0b11110101){
				__delay_us(1);							//	1ҋ@igxĂ̂łłPr炢̂͂j
				if((PORTB & 0b11110101) != 0b11110101){	// Qx
					break;								// [v甲
				}
			}
		}

		OSCCON	= 0b01110000;							//	Change 8MHz
		OSCCON	= 0b11110000;							//	PLL Enable 32MHz(8MHz x 4)

#endif

	}


}
